/*
Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR

This file is part of SMPPIR-CheckIn.

SMPPIR-CheckIn is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SMPPIR-CheckIn is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SMPPIR-CheckIn.  If not, see <https://www.gnu.org/licenses/>.
*/

'use strict';

module.exports = function(Category) {
    Category.csvexport = function(res, callback ) {
        var datetime = new Date();
        var datetimeFuture = new Date(datetime.getFullYear(), datetime.getMonth(), datetime.getDate()+7)
        res.set('Expires', datetimeFuture+'');
        res.set('Cache-Control', 'max-age=0, no-cache, must-revalidate, proxy-revalidate');
        res.set('Last-Modified', datetime+'');
        res.set('Content-Type','application/force-download');
        res.set('Content-Type','application/octet-stream');
        res.set('Content-Type','application/download');
        res.set('Content-Disposition','attachment;filename=category.csv');
        res.set('Content-Transfer-Encoding','binary');

        Category.find(function(err, categories)
        {
              // conversão JSON para CSV
              // cabeçalho do csv
              var headers = {
                category_name: "category_name",
                category_description: "category_description",
                id: "id"
              };

              //Adiciona os headers no CSV
              categories.unshift(headers);
            
              var jsonObject = JSON.stringify(categories);
              var array = typeof jsonObject != 'object' ? JSON.parse(jsonObject) : jsonObject;
              var csv = '';
          
              for (var i = 0; i < array.length; i++) {
                var line = '';
                for (var index in array[i]) {
                  if (line != '') line += ';' // aqui muda o separador do csv
                    line += array[i][index];
                }
                csv += line + '\n';
              }   
            res.send(csv);
        });
    };

    Category.remoteMethod('csvexport',
      {
        accepts: [
          {arg: 'res', type: 'object', 'http': {source: 'res'}}
        ],
        returns: {},
        http: {path: '/csv', verb: 'get'},
      });
};
