/*
Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR

This file is part of SMPPIR-CheckIn.

SMPPIR-CheckIn is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SMPPIR-CheckIn is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SMPPIR-CheckIn.  If not, see <https://www.gnu.org/licenses/>.
*/

'use strict';

module.exports = function(Geolocation) {
    Geolocation.csvexport = function(type, res, callback ) {
        if (type == "padrao" || type == "android"){
          var datetime = new Date();
          var datetimeFuture = new Date(datetime.getFullYear(), datetime.getMonth(), datetime.getDate()+7)
          res.set('Expires', datetimeFuture+'');
          res.set('Cache-Control', 'max-age=0, no-cache, must-revalidate, proxy-revalidate');
          res.set('Last-Modified', datetime +'');
          res.set('Content-Type','application/force-download');
          res.set('Content-Type','application/octet-stream');
          res.set('Content-Type','application/download');
          res.set('Content-Disposition','attachment;filename=geolocation.csv');
          res.set('Content-Transfer-Encoding','binary');

          Geolocation.find(function(err, geolocations) {            
                // conversão JSON para CSV
                // cabeçalho do csv  
                var headers = {
                    category_id: "category_id",
                    geolocation_name: "geolocation_name",
                    latitude: "latitude",
                    longitude: "longitude",
                    when_sent: "when_sent",
                    description_location: "description_location",
                    user_id: "user_id",
                    id: "id"
                  };                    
                  
                // cabeçalho do csv - Adiciona android_id                
                if (type == "android"){
                    headers['android_id'] = "android_id"
                }
                
                //Ordena header
                var ordered_header = {}
                Object.keys(headers).sort().forEach(function(key) {
                    ordered_header[key] = headers[key];
                });
                
                //Adiciona os headers no CSV
                geolocations.unshift(headers);
              
                // Posição do Android ID 4 atualmente esta em 8
                var jsonObject = JSON.stringify(geolocations);
                var array = typeof jsonObject != 'object' ? JSON.parse(jsonObject) : jsonObject;
                var csv = '';
            
                for (let i = 0; i < array.length; i++) {
                  var line = '';
                  var aux = {}
                  Object.keys(array[i]).sort().forEach(function(key) {
                      aux[key] = array[i][key];
                  });
                  if (type == "padrao"){
                     delete aux["android_id"];
                  }
                  for (let index in aux) {
                    if (line != '') line += ';' // aqui muda o separador do csv
                      line += array[i][index];
                  }
                  csv += line + '\n';
                }   
              res.send(csv);
          });
        }
    };

    Geolocation.remoteMethod('csvexport',
      {
        accepts: [
          {arg: 'type', type: 'string'},
          {arg: 'res', type: 'object', 'http': {source: 'res'}}
        ],
        returns: {},
        http: {path: '/csv/:type', verb: 'get'}
      });
};
