/*
Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR

This file is part of SMPPIR-CheckIn.

SMPPIR-CheckIn is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SMPPIR-CheckIn is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SMPPIR-CheckIn.  If not, see <https://www.gnu.org/licenses/>.
*/

const URL = 'http://localhost:4001/api/';

const randomLowerCase = function() {
  let possible = 'abcdefghijklmnopqrstuvwxyz';
  return (possible.charAt(Math.floor(Math.random() * possible.length)));
};

const randomUpperCase = function() {
  let possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  return (possible.charAt(Math.floor(Math.random() * possible.length)));
};

const randomNumber = function(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return (Math.floor(Math.random() * (max - min + 1)) + min);
};

const randomWord = function(num, allUpper = false, firstUpper = false) {
  let word = '';
  for (let i = 0; i < num; i++) {
    if (!allUpper) {
      if (i == 0 && firstUpper) {
        word = word + randomUpperCase();
      } else {
        word = word + randomLowerCase();
      }
    } else {
      word = word + randomUpperCase();
    }
  }
  return word;
};

const randomId = function(num) {
  let word = '';
  for (let i = 0; i < num; i++) {
    if (randomNumber(0, 1) == 0) {
      word = word + randomNumber(0, 9);
    } else {
      word = word + randomLowerCase();
    }
  }
  return word;
};

module.exports = {
  URL,
  randomLowerCase,
  randomUpperCase,
  randomNumber,
  randomWord,
  randomId,
};
