/*
Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR

This file is part of SMPPIR-CheckIn.

SMPPIR-CheckIn is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SMPPIR-CheckIn is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SMPPIR-CheckIn.  If not, see <https://www.gnu.org/licenses/>.
*/

/*
2 Permissions : admin, user

user: GET category, geolocation, own profile, number of users
      UPDATE own profile
      POST geolocation

admin: GET all
       POST all
       UPDATE all
       DELETE all
*/

module.exports = function(app) {
    var Role = app.models.Role;

    Role.registerResolver('admin', function(role, context, cb) {
        function reject() {
          process.nextTick(function() {
            cb(null, false);
          });
        }   

        switch (context.modelName){
            case 'end_user':
                break;
            case 'geolocation':
                break;
            case 'category':
                break;
            default:
                return reject();
        }

        var userId = context.accessToken.userId;
        if (!userId) {
          return reject();
        }
  
        context.model.findById(userId, function(err, model) {
            app.models.EndUser.findById(userId, function(err2, user){
                if ((err || !model ) && (err2 || !user))
                    return reject();
                if(user.permission !== role)
                    return reject();
                else 
                    return cb(null,true)
            })            
        });
    });


    Role.registerResolver('user', function(role, context, cb) {
        function reject() {
          process.nextTick(function() {
            cb(null, false);
          });
        }   

        switch (context.modelName){
            case 'end_user':
                break;
            case 'geolocation':
                break;
            case 'category':
                break;
            default:
                return reject();
        }

        var userId = context.accessToken.userId;
        if (!userId) {
          return reject();
        }
  
        context.model.findById(userId, function(err, model) {

            app.models.EndUser.findById(userId, function(err2, user){
                if ((err || !model ) && (err2 || !user))
                    return reject();
                if(user.permission !== role)
                    return reject();
                else 
                    return cb(null,true)
            })            
        });
    });
  };